﻿;==============================================================================================================================================================================
; Remove borders from various gadgets
;==============================================================================================================================================================================

Procedure RemoveBorders(GadgetConstant.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Get the gadget type from the passed gadget constant
  ;------------------------------------------------------------------------------------------------

  GadgetType.i = GadgetType(GadgetConstant.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Select the gadget type
  ;------------------------------------------------------------------------------------------------
  
  Select GadgetType.i

    ;----------------------------------------------------------------------------------------------
    ; Do the below if it is a ListIconGadget
    ;----------------------------------------------------------------------------------------------
    
    Case  #PB_GadgetType_ListIcon
      
      ;--------------------------------------------------------------------------------------------
      ; Remove borders from ListIconGadgets
      ;--------------------------------------------------------------------------------------------
      
      OldStyle.i  = GetWindowLongPtr_(GadgetID(GadgetConstant.i), #GWL_EXSTYLE)
      
      NewStyle.i  = OldStyle.i & ( ~ #WS_EX_CLIENTEDGE)
      
      SetWindowLongPtr_(GadgetID(GadgetConstant.i), #GWL_EXSTYLE, NewStyle.i)
      
      SetWindowPos_(GadgetID(GadgetConstant.i), 0, 0, 0, 0, 0, #SWP_SHOWWINDOW | #SWP_NOSIZE | #SWP_NOMOVE | #SWP_FRAMECHANGED)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------

    Case #PB_GadgetType_Editor
      
      ;--------------------------------------------------------------------------------------------
      ; Remove border from editorgadget (comment) field. Stiil leaves a 1 pixel border but that looks good here
      ;--------------------------------------------------------------------------------------------
      
      ;       SetWindowLongPtr_(GadgetID(GadgetConstant.i), #GWL_EXSTYLE, GetWindowLongPtr_(GadgetID(GadgetConstant.i), #GWL_EXSTYLE) & (~#WS_EX_CLIENTEDGE))
      ;       
      ;       SetWindowPos_(GadgetID(GadgetConstant.i), 0, 0, 0, 0, 0, #SWP_SHOWWINDOW | #SWP_NOSIZE | #SWP_NOMOVE | #SWP_FRAMECHANGED)
  
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      OldStyle.i  = GetWindowLongPtr_(GadgetID(GadgetConstant.i), #GWL_EXSTYLE)
      
      NewStyle.i  = OldStyle.i & ( ~ #WS_EX_CLIENTEDGE)
      
      SetWindowLongPtr_(GadgetID(GadgetConstant.i), #GWL_EXSTYLE, NewStyle.i)
      
      SetWindowTheme_(GadgetID(GadgetConstant.i), @null.w, @null.w)
      
      ; SetWindowPos_(GadgetID(1), 0, 0, 0, 0, 0, #SWP_SHOWWINDOW | #SWP_NOSIZE | #SWP_NOMOVE | #SWP_FRAMECHANGED) ; required for this to work on my Win98
      ; -- End removing border from EditorGadget --
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure



; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 4
; Folding = -
; EnableAsm
; EnableXP