﻿;==============================================================================================================================================================================
; Handle the fake statusbar area messages
;==============================================================================================================================================================================

Procedure SetInfoBarArea(FieldName.s, FieldStatus.s = "##Error##", MessageContent.s = "0", ModuleName.s = #Empty$)
  
  ;------------------------------------------------------------------------------------------------
  ; Select the name of the field to put our heading string
  ;------------------------------------------------------------------------------------------------
  
  Select FieldName.s
    
    ;----------------------------------------------------------------------------------------------
    ; Select the correct heading by the status field
    ;----------------------------------------------------------------------------------------------
    
    Case "Headings"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Select FieldStatus.s
          
        Case "Welcome"
          
          MessageHeader.s = "Welcome"
          
          Colour.i        = $615E5F
          
        Case "Info"
          
          MessageHeader.s = "Information"
          
          Colour.i        = $DB3D24
          
        Case "Warn"
          
          MessageHeader.s = "Warning"
          
          Colour.i        = $7D1F82
          
        Case "Tool"
          
          MessageHeader.s = "Tooltip"
          
          Colour.i        = $FF0000
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; Send all the strings to the fake status bar area
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_Recipeview_sStatus,     MessageHeader.s)
      
      SetGadgetText(#Gadget_Recipeview_sMessage,    MessageContent.s)
      
      SetGadgetColor(#Gadget_Recipeview_sStatus,    #PB_Gadget_FrontColor, Colour.i)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case "Current"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_Recipeview_sCurrent, "Recipe " + MessageContent.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case "Records"
      
      ;--------------------------------------------------------------------------------------------
      ; Figure out the correct spelling for the record field for singles or multiples
      ;--------------------------------------------------------------------------------------------
      
      If Val(MessageContent.s)      = 0
        
        RecordHeader.s = "Recipes"
        
      ElseIf Val(MessageContent.s) = 1
        
        RecordHeader.s = "Recipe"
        
      ElseIf Val(MessageContent.s) > = 2
        
        RecordHeader.s = "Recipes"
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Set the record number details in the fake status bar area
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_Recipeview_sRecords, FormatNumber(ValD(MessageContent.s), 0, ".", ",") + " " + RecordHeader.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 114
; FirstLine = 69
; Folding = -
; EnableAsm
; EnableXP