;============================================================================================================================================================
; Read the system preferences file or create it if missing
;============================================================================================================================================================

Procedure ReadPreferencesFile()
  
  ;------------------------------------------------------------------------------------------------
  ; If the INI file doesn't exist, create a default one
  ;------------------------------------------------------------------------------------------------
  
  If FileSize(Program\InitialisationFile.s) = -1

    CreatePreferencesFile()

  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If OpenPreferences(Program\InitialisationFile.s) <> #BadPreferencesFile
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    PreferenceGroup("Program Options")
    
    ;----------------------------------------------------------------------------------------------
    ; Program Toggles
    ;----------------------------------------------------------------------------------------------
    
    Program\LastDirectorySearched.s = ReadPreferenceString("Last Directory Searched", "D:\bangf\Documents\Sue Bolvary (Mookie)\Cooking & Recipes\")
  
    Program\LastStringSearched.s    = ReadPreferenceString("Last String Searched",  #Empty$)
  
    Program\ScreenSnap.i            = ReadPreferenceLong("Snap To Screen",          #False)
  
    Program\ToolTips.i              = ReadPreferenceLong("Tool Tips",               #False)
  
    Program\TitleClock.i            = ReadPreferenceLong("Title Clock",             #False)
    
    Program\StickyWindow.i          = ReadPreferenceLong("Sticky Window",           #False)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ClosePreferences()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings",  "Error",  "Preferences file missing or damaged", #PB_Compiler_Procedure)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.61 (Windows - x86)
; Folding = -
; DisableDebugger
; HideErrorLog