﻿;==========================================================================================================================================================
; Search and list recipes from a directory
;==========================================================================================================================================================

Procedure SearchEngine(Searchpath.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  PseudoCounter.i = 0
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ClearList(FoundDirectories.s())
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Searchpath.s <> #Empty$
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Right(Searchpath.s, 1) = "\"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Searchpath.s = Left(Searchpath.s, Len(Searchpath.s) - 1)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    AddElement(FoundDirectories.s())
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FoundDirectories.s() = Searchpath.s
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Index.i = 0
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Repeat
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SelectElement(FoundDirectories.s(), Index.i)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Directory.i = ExamineDirectory(#PB_Any, FoundDirectories.s(), "*.*")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If Directory.i
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        Path.s = FoundDirectories.s() + "\"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        While NextDirectoryEntry(Directory.i)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          Filename.s = DirectoryEntryName(Directory.i)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          Select DirectoryEntryType(Directory.i)
              
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
              
            Case #PB_DirectoryEntry_File
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              If LCase(GetExtensionPart(Filename.s)) = "pdf"
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                CurrentRecipeName.s = Left(Filename.s, Len(Filename.s)  - Len(GetExtensionPart(Filename.s)) - 1)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                CurrentCategory.s   = Path.s
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                If Len(CurrentRecipeName.s) And Len(CurrentCategory.s)
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  AddGadgetItem(#Gadget_Recipeview_Recipenames, #AtTheEndOfTheList, CurrentRecipeName.s  + #LF$  + Path.s, ImageID(#Image_Recipeview_List))
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  PseudoCounter.i + 1
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  AddElement(Recipes())
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  Recipes()\Recipename.s      = CurrentRecipeName.s
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  Recipes()\RecipeCategory.s  = CurrentCategory.s
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                Else
                  
                  SetInfoBarArea("Headings",  "Error",  "Recipe name or directory is empty", #PB_Compiler_Procedure)
                  
                EndIf
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
              Else
                
                SetInfoBarArea("Headings",  "Error",  "This isn't a PDF file so ignore it", #PB_Compiler_Procedure)
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Case #PB_DirectoryEntry_Directory
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              Filename.s = DirectoryEntryName(Directory.i)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              If Filename.s <> ".." And Filename.s <> "."
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                AddElement(FoundDirectories())
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                FoundDirectories() = Path.s + Filename.s
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
          EndSelect
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Wend
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        FinishDirectory(Directory.i)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Index.i + 1
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Until Index.i > ListSize(FoundDirectories()) -1
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CountGadgetItems(#Gadget_Recipeview_Recipenames)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetState(#Gadget_Recipeview_Recipenames, #FirstItemInList)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetItemState(#Gadget_Recipeview_Recipenames, #FirstItemInList, #PB_ListIcon_Selected)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Records",   #Empty$, Str(CountGadgetItems(#Gadget_Recipeview_Recipenames)))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    PostEvent(#PB_Event_Gadget, #Window_Recipeview, #Gadget_Recipeview_Recipenames, #PB_EventType_Change)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error",  "There were no PDF recipes files found in the directory", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 298
; FirstLine = 265
; Folding = -
; EnableAsm
; EnableXP