﻿;==============================================================================================================================================================================
; Extended balloon tooltip with images support by using the O/S's theming engine
;==============================================================================================================================================================================

Import "Uxtheme.lib"                                                                                 ; 
  SetWindowTheme(Window.i, Body.p-unicode, Title.p-unicode)                                           ;  
EndImport                                                                                            ; 

;==============================================================================================================================================================================
; My personal constants
;==============================================================================================================================================================================

#Author                         = "Miklós G Bolváry"                                                  ; Author's name
#CopyRight                      = "MGB Technical Services 2018 "                                      ; Copyright holder
#Basename                       = "RecipeView "                                                       ; Base name for initialisation file and database
#Version                        = "v0.00."                                                            ; Program version
#Program                        = #Basename + #Version                                                ; Copyright string
#SystrayNote                    = "Hello, "+ #Program + " is hiding here"                             ; System tray note

;==========================================================================================================================================================
; File and list related constants
;==========================================================================================================================================================

#Fish                           = "<°)))o><²³  "                                                      ; Beware the fish!!

#AtTheEndOfTheList              = -1                                                                  ; 
#FirstItemInList                =  0                                                                  ; 

#NoFileCreated                  =  0                                                                  ; 

#BadPreferencesFile             =  0                                                                  ; 

#NoFileFound                    = -1                                                                  ; 
#NoFileRead                     =  0                                                                  ; 
#FileIsDirectory                = -2                                                                  ; 
  
;==========================================================================================================================================================
; Main program variables
;==========================================================================================================================================================

Structure ProgramData                                                                                ; 
  QuitValue.i                                                                                         ; 
  
  CurrentDirectory.s                                                                                  ; 
  CurrentDate.s                                                                                       ; 
  
  LastSelectedRecipe.i                                                                                ; 
  CompileCounters.s                                                                                   ; Compiler and build counter
  
  ; Dealing with search cues in search boxes
  
  SearchCueFont.i                                                                                     ; Searchbox cue font
  SearchNormalFont.i                                                                                  ; Searchbox normal font
  SearchCueText.s                                                                                     ; The cue text to be passed to search windows
  
  ; Balloon tooltip parameters
  
  BalloonFontId.i                                                                                     ; Balloon tooltip font
  BalloonWindowId.i                                                                                   ; Current balloon window
  
  OldWindowTitle.s                                                                                    ; Old window title for changing or adding to
  
  TimeOffset.i                                                                                        ; Time zone offset, used for UTC calculations
  
  LastDirectorySearched.s                                                                             ; 
  LastStringSearched.s                                                                                ; 
  
  InitialisationFile.s                                                                                ; 
  
  ScreenSnap.i                                                                                        ; 
  ToolTips.i                                                                                          ; 
  TitleClock.i                                                                                        ; 
  StickyWindow.i                                                                                      ; 
EndStructure                                                                                         ; 
  
;==========================================================================================================================================================
; Recipe names and categories for linked list search
;==========================================================================================================================================================

Structure RecipeNames                                                                                ; 
  Recipename.s                                                                                        ; 
  RecipeCategory.s                                                                                    ; 
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; Custom date routine structure
;==============================================================================================================================================================================

Structure DateStructure                                                                              ; Custom date routine
  Year.w                                                                                              ; 
  Month.w                                                                                             ; 
  DayOfWeek.w                                                                                         ; 
  Day.w                                                                                               ; 
  Hour.w                                                                                              ; 
  Minute.w                                                                                            ; 
  Second.w                                                                                            ; 
  Milliseconds.w                                                                                      ; 
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; Tooltip structure data
;==============================================================================================================================================================================

Structure ToolTipData                                                                                ; If any tooltips setup, keep track of gadgets that have them so you can remove them if needed
  pbWindowNumber.i                                                                                    ; 
  pbHandleTip.i                                                                                       ; 
  pbGadgetID.i                                                                                        ; 
  pbGadgetNumber.i                                                                                    ; 
  pbIconHandle.i                                                                                      ; 
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; Button glow effects structure
;==============================================================================================================================================================================

Structure GlowData                                                                                   ; 
  GlowColour.l                                                                                        ; 
  GlowRadius.i                                                                                        ; 
  ExtendCanvas.i                                                                                      ; 
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; Short key and menu text
;==============================================================================================================================================================================

Structure ShortKeyData                                                                               ; 
  RecipeView_GetRecipes.s                                                                             ; 
  RecipeView_PrintRecipe.s                                                                            ; 
  RecipeView_ScreenSnap.s                                                                             ; 
  RecipeView_ToolTips.s                                                                               ; 
  RecipeView_TitleClock.s                                                                             ; 
  RecipeView_StickyWindow.s                                                                           ; 
  RecipeView_HelpProgram.s                                                                            ; 
  RecipeView_ExitProgram.s                                                                            ; 
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; Long key and menu text
;==============================================================================================================================================================================

Structure LongKeyData                                                                                ; 
  RecipeView_GetRecipes.s                                                                             ; 
  RecipeView_PrintRecipe.s                                                                            ; 
  RecipeView_ScreenSnap.s                                                                             ; 
  RecipeView_ToolTips.s                                                                               ; 
  RecipeView_TitleClock.s                                                                             ; 
  RecipeView_StickyWindow.s                                                                           ; 
  RecipeView_HelpProgram.s                                                                            ; 
  RecipeView_ExitProgram.s                                                                            ; 
EndStructure                                                                                         ; 
  
;==========================================================================================================================================================
; All global variables
;==========================================================================================================================================================

Global Program.ProgramData                                                                            ; 
Global ShortKey.ShortKeyData                                                                          ; All language strings
Global LongKey.LongKeyData                                                                            ; All language strings
Global Glow.GlowData                                                                                  ; Icon glow outline
Global Balloon.TOOLINFO                                                                               ; Balloon tooltips
Global td.SYSTEMTIME                                                                                  ; This is used as interface for time and date conversions

;==========================================================================================================================================================
; Global list declarations
;==========================================================================================================================================================

Global NewList Recipes.RecipeNames()                                                                 ; 
Global NewList FoundDirectories.s()                                                                  ; List of dirs found by the search engine
Global NewList ToolTips.ToolTipData()                                                                ; All tool tip handles and data here

;==============================================================================================================================================================================
; Create your program directories
;==============================================================================================================================================================================

Program\CompileCounters     = Str(#PB_Editor_CompileCount) + "." + Str(#PB_Editor_BuildCount) + "a"   ; Add to program version

;==============================================================================================================================================================================
; Initial program window quit state
;==============================================================================================================================================================================

Program\QuitValue           =  #False                                                                 ; Initial program quit value

;==========================================================================================================================================================
; Get the current working directory
;==========================================================================================================================================================

Program\CurrentDirectory.s  = GetCurrentDirectory()                                                   ; 

;==============================================================================================================================================================================
; Program preferences file
;==============================================================================================================================================================================

Program\InitialisationFile.s  = Program\CurrentDirectory.s + #Basename + ".prefs"                     ; 

;==============================================================================================================================================================================
; Setup the search box cue fonts
;==============================================================================================================================================================================

Program\SearchCueFont         = LoadFont(#PB_Any,   "Georgia",     10, #PB_Font_Italic)               ; Empty search cue font
Program\SearchNormalFont      = LoadFont(#PB_Any,   "Segoe Print", 10, 0)                             ; Filled cue box font

Program\SearchCueText.s       = Space(256)                                                            ; Set the cue text buffer

PokeS(@Program\SearchCueText, "Type your search string in here", -1, #PB_Unicode)                     ; 

;==============================================================================================================================================================================
; Glowing outline on form buttons
;==============================================================================================================================================================================

Glow\GlowColour   = $19121E                                                                           ; 
Glow\GlowRadius   = 4                                                                                 ; 
Glow\ExtendCanvas = #False                                                                            ; 

;==============================================================================================================================================================================
; NetMaestro's screen snap code
;==============================================================================================================================================================================

Global ScreenW.i, ScreenH.i, SnapD.i = 50, AutoSnap.i = #True                                        ;

Define wa.RECT                                                                                       ; 

SystemParametersInfo_(#SPI_GETWORKAREA, 0, @wa.RECT, 0)                                               ; Client area of the desktop

ScreenW.i = wa\right                                                                                  ;

screenH.i = wa\bottom                                                                                 ;

;==============================================================================================================================================================================
; Get time zone information used for UTC calculations (Baldrick)
;==============================================================================================================================================================================

#MinutesPerHour = 60

Select GetTimeZoneInformation_(Tz.Time_zone_information) 
  Case #TIME_ZONE_ID_INVALID   : MessageRequester("Time Zone error", "Your Windows time zone id appears to be invalid?.", #PB_MessageRequester_Ok)
  Case #TIME_ZONE_ID_UNKNOWN   : MessageRequester("Time Zone error", "Your Windows time zone id appears to be invalid?.", #PB_MessageRequester_Ok)
  Case #TIME_ZONE_ID_STANDARD  : Program\TimeOffset = (Tz\Bias + Tz\StandardBias)
  Case #TIME_ZONE_ID_DAYLIGHT  : Program\TimeOffset = (Tz\Bias + Tz\DaylightBias)
EndSelect

;==============================================================================================================================================================================
; Date and time testing, date display on title bar
;==============================================================================================================================================================================

Program\CurrentDate         = FormatDate("%dd/%mm/%yyyy", Date())                                     ; Get the current system date without the time component

;==============================================================================================================================================================================
; Fonts to be used on the ballon tips
;==============================================================================================================================================================================

Program\BalloonFontId       = LoadFont(#PB_Any, "Segoe Print", 10, #PB_Font_HighQuality | #PB_Font_Italic)

;==============================================================================================================================================================================
; Short keyboard shortcut definitions
;==============================================================================================================================================================================

#Keys_RecipeView_StartSearching     =                    #PB_Shortcut_Return                            ; 
#Keys_RecipeView_GetRecipes         = #PB_Shortcut_Alt | #PB_Shortcut_G                                 ; 
#Keys_RecipeView_PrintRecipe        = #PB_Shortcut_Alt | #PB_Shortcut_P                                 ; 
#Keys_RecipeView_ScreenSnap         = #PB_Shortcut_Alt | #PB_Shortcut_S                                 ; 
#Keys_RecipeView_ToolTips           = #PB_Shortcut_Alt | #PB_Shortcut_T                                 ; 
#Keys_RecipeView_TitleClock         = #PB_Shortcut_Alt | #PB_Shortcut_C                                 ; 
#Keys_RecipeView_StickyWindow       = #PB_Shortcut_Alt | #PB_Shortcut_W                                 ; 
#Keys_RecipeView_HelpProgram        = #PB_Shortcut_Alt | #PB_Shortcut_H                                 ; 
#Keys_RecipeView_ExitProgram        = #PB_Shortcut_Alt | #PB_Shortcut_X                                 ; 

;==============================================================================================================================================================================
; Short key text explanations
;==============================================================================================================================================================================

ShortKey\RecipeView_GetRecipes.s    = "Get all recipes"                                                 ; 
ShortKey\RecipeView_PrintRecipe.s   = "Print selected recipe"                                           ; 
ShortKey\RecipeView_ScreenSnap.s    = "Snap to edges"                                                   ; 
ShortKey\RecipeView_ToolTips.s      = "Show tooltips"                                                   ; 
ShortKey\RecipeView_TitleClock.s    = "Titlebar clock"                                                  ; 
ShortKey\RecipeView_StickyWindow.s  = "Stick on top"                                                    ; 
ShortKey\RecipeView_HelpProgram.s   = "Show program help"                                               ; 
ShortKey\RecipeView_ExitProgram.s   = "Exit the program"                                                ; 
  
;==============================================================================================================================================================================
; Long key text explanations
;==============================================================================================================================================================================
  
LongKey\RecipeView_GetRecipes.s     = "Scan selected directory and display all recipes"                 ; 
LongKey\RecipeView_PrintRecipe.s    = "Print the currently selected recipe"                             ; 
LongKey\RecipeView_ScreenSnap.s     = "Snap the screen to desktop borders"                              ; 
LongKey\RecipeView_ToolTips.s       = "Turn button tooltips on or off"                                  ; 
LongKey\RecipeView_TitleClock.s     = "Turn the titlebar clock on or off"                               ; 
LongKey\RecipeView_StickyWindow.s   = "Stick the program window on top of everything"                   ; 
LongKey\RecipeView_HelpProgram.s    = "Show any available program help"                                 ; 
LongKey\RecipeView_ExitProgram.s    = "Exit this program immediately"                                   ; 

;==============================================================================================================================================================================
; Setup day and month literal names
;==============================================================================================================================================================================

Define DaysPerMonthFill.i                                                                             ; 

Global Dim NameOfDay.s(7)                                                                             ; Fill an array with the names of the days (Terry Hough I think)

  NameOfDay(0)      = "Sunday"
  NameOfDay(1)      = "Monday"
  NameOfDay(2)      = "Tuesday"
  NameOfDay(3)      = "Wednesday"
  NameOfDay(4)      = "Thursday"
  NameOfDay(5)      = "Friday"
  NameOfDay(6)      = "Saturday"

Global Dim DaysPerMonth(12)                                                                           ; Fill an array on how many days per month there are

  For DaysPerMonthFill.i = 0 To 11     
    DaysPerMonth(DaysPerMonthFill.i) = 31 
  Next

  DaysPerMonth(1)   = 28
  DaysPerMonth(3)   = 30
  DaysPerMonth(5)   = 30
  DaysPerMonth(8)   = 30
  DaysPerMonth(10)  = 30

Global Dim NameOfMonth.s(12)                                                                          ; Fill an array with the names of the months

  NameOfMonth(0)    = "January"
  NameOfMonth(1)    = "February"
  NameOfMonth(2)    = "March"
  NameOfMonth(3)    = "April"
  NameOfMonth(4)    = "May"
  NameOfMonth(5)    = "June"
  NameOfMonth(6)    = "July"
  NameOfMonth(7)    = "August"
  NameOfMonth(8)    = "September"
  NameOfMonth(9)    = "October"
  NameOfMonth(10)   = "November"
  NameOfMonth(11)   = "December"

Global Dim Years.s(19)                                                                                ; Fill an array with the years

  Years(0)          = "2002"
  Years(1)          = "2003"
  Years(2)          = "2004"
  Years(3)          = "2005"
  Years(4)          = "2006" 
  Years(5)          = "2007"
  Years(6)          = "2008"
  Years(7)          = "2009"
  Years(8)          = "2010"
  Years(9)          = "2011"
  Years(10)         = "2012"
  Years(11)         = "2013"
  Years(12)         = "2014"
  Years(13)         = "2015"
  Years(14)         = "2016"
  Years(15)         = "2017"
  Years(16)         = "2018"
  Years(17)         = "2019"
  Years(18)         = "2020"

;==============================================================================================================================================================================
; Program shortcut keys
;==============================================================================================================================================================================
  
Enumeration #GadgetIndex                                                                             ; 
  #TitleClockTimerEvent                                                                               ; 

  #Shortcut_RecipeView_StartSearching                                                                 ; 
  
  #Shortcut_RecipeView_GetRecipes                                                                     ; 
  #Shortcut_RecipeView_PrintRecipe                                                                    ; 
  #Shortcut_RecipeView_ScreenSnap                                                                     ; 
  #Shortcut_RecipeView_ToolTips                                                                       ; 
  #Shortcut_RecipeView_TitleClock                                                                     ; 
  #Shortcut_RecipeView_StickyWindow                                                                   ; 
  #Shortcut_RecipeView_HelpProgram                                                                    ; 
  #Shortcut_RecipeView_ExitProgram                                                                    ; 
EndEnumeration                                                                                       ; 

;==============================================================================================================================================================================
; Any image enumerations
;==============================================================================================================================================================================

Enumeration #ImageIndex                                                                              ; 
  #Image_Recipeview_List                                                                              ; 
EndEnumeration                                                                                       ; 

;==============================================================================================================================================================================
; Grab images into memory
;==============================================================================================================================================================================

CatchImage(#Image_Recipeview_List,              ?_Image_Recipeview_List)                              ; 

;==============================================================================================================================================================================
; Datasection references to images
;==============================================================================================================================================================================

DataSection
  _Image_Recipeview_List:                        : IncludeBinary "Images\_16x16\Recipe.ico"          ; 
EndDataSection

; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 192
; FirstLine = 186
; EnableAsm
; EnableXP
; EnableCompileCount = 0
; EnableBuildCount = 0