﻿;==========================================================================================================================================================
; Generic procedures
;==========================================================================================================================================================

Declare.s FormatField(InString.s, FieldLen.i)                                                         ; Format the passed string to the correct field length for printing
Declare.s GetShortcutText(Constant.i)                                                                 ; Get the text of the associated shortcut constant. SROD
Declare   LastLine(Gadget.i, LineNumber.i)                                                            ; Go to the last line of a ListIconGadget
Declare   RemoveBorders(GadgetConstant.i)                                                             ; Remove borders from various gadgets

;==========================================================================================================================================================
; Custom procedures
;==========================================================================================================================================================

Declare   BalloonToolTip(pbWindowNumber.i, pbGadgetNumber.i, pbFontHandle.i, balloonColour.i, balloonTipTitle.s, balloonTipText.s,  pbIconHandle.i) ; Add balloon tooltips with individual fonts and icons
Declare.i GetIconHandle(ImageConstant.i)                                                              ; Copy the icon into memory while deleting the original image copied from. RASHAD's modification
Declare   SetDate(WindowId.i)                                                                         ; Sort out the date and display it
Declare   SetHoverIcons(Gadget.i, Image.i, State.s)                                                   ; Set the correct icons to the selected hoverable gadget
Declare   StatusBarButtonTip(WindowNumber.i, ButtonItem.s)                                            ; Set and display button toolbar/menu text in the statusbar
Declare   TitleBarClock(ObjectHandle.i, Message.i, EventNumber.i, TimePeriod.i)                       ; Run an asynchronous clock in the window title bar
Declare   WindowCallback(WindowID, Message, wParam, lParam)                                           ; Window snap, strikeoutfont and more
Declare.s WordWrapString(SourceString.s, StringWidth.i, DelimiterList.s = "- " + #TAB$, NewLineString.s = #LF$)  ; Wrap a string to a specified boundary

;==========================================================================================================================================================
; Program helpers
;==========================================================================================================================================================

Declare   GetRecipeDirectory()                                                                        ; Scan recipe directory and load filenames
Declare   SetInfoBarArea(FieldName.s, FieldStatus.s = "##Error##", MessageContent.s = "0", ModuleName.s = #Empty$)  ; Handle the fake statusbar area messages

;==========================================================================================================================================================
; Recipe related procedures
;==========================================================================================================================================================

Declare   SearchEngine(Searchpath.s)                                                                  ; Search and list recipes from a directory
Declare   SearchRecipes()                                                                             ; Search recipes in linked list and display matches
Declare   ShowRecipe()                                                                                ; Load the recipe into the webgadget to display it

;==============================================================================================================================================================================
; Various program toggles
;==============================================================================================================================================================================

Declare   ToggleScreenSnap()                                                                          ; Turn snapping to screen borders on and off
Declare   ToggleToolTips()                                                                            ; Turn tool tips on and off as needed
Declare   ToggleTitleBarClock()                                                                       ; Turn time updating on in the title bar
Declare   ToggleStickyWindow()                                                                        ; Set this window on top of others or alarm window will not show

;==========================================================================================================================================================
; Preference file handling
;==========================================================================================================================================================

Declare   CreatePreferencesFile()                                                                     ; Create a brand new INI file in the program directory if the default one is missing, with default values.
Declare   ReadPreferencesFile()                                                                       ; Read the system preferences file or create it if missing
Declare   SavePreferencesFile()                                                                       ; Read the system preferences file or create it if missing

; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 44
; EnableAsm
; EnableXP